import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;

/**Documentation file*/


public class DocInstructions {

    public DocInstructions() {}

    public static void setup(DocumentCanvas D) {
    
	String S="Sol Geometry Explorer\n";
	S=S+"by Rich Schwartz\n";
	S=S+"program started: October 2019\n";
	S=S+"Last updated:  10 Feb 2020\n";


	S=S+"\n\nPURPOSE:\n\n";
	S=S+"This program computes geodesics and geodesic spheres in SOL by numerically integrating the assoiciated Hamiltonian vector  field.   The basic idea goes back to V. I. Arnold in the 1960s, and then was used to great effect by  Matt Grayson in the 1980s, when he wrote his Princeton PhD thesis.  Matei Coiculescu and I have been investigating this way of computing geodesics.  Now the program can draw the spheres even beyond the critical radius where singularities develop.  This program is a companion to the paper about this stuff that Matei and I wrote..";

	    S=S+"\n\nOPERATING INSTRUCTIONS\n\n";

	    S=S+"Here is some information about this text window. This window gives explanations for the rest of the program.  Drag the mouse over the text to scroll up or down. There is more text than what is now visible.  You can resize this window and  also change the font size.";

	    S=S+"\n\nThis program is designed to work best with a 3 button mouse. On the picture windows, buttoms 1 and 3 zoom in and out of the picture and button 2 generally selects a new point. If you don't have a 3 button mouse, you can use the keyboard buttons z,x,c to simulate the 3 buttons when you are operating any of the windows where you might want to rescale the picture.";

	    S=S+"\n\nSome of the windows in this program are popups. You push the button on the popup control panel to summon the window.  If you open the same window more than once, the thing malfunctions. In this case just kill all copies of the window including the origin and summon it again.";

	    S=S+"\n\nThis program has a number of sliders. The sliders have arrow keys and boxes to their right. You change the value of a slider  by dragging the mouse along the bar.  You can use the arrow keys to multiply the value by a selected power of 2.  The squares to the far right reset the slider bar.  Just try it to see how it works.";

	    S=S+"The Vector Selection Window and the SOL Sphere window are resizeable.";

	    S=S+"The various question boxes give additional information about the associated features when they are pressed.  The question box at the top of this window returns the text in this window to its original configuration.  Try pressing the question boxes to see what they do.";


	    S=S+"\n\nLIST OF WINDOWS";

	    S=S+"\n\nAside from this window, the program has 6 pther windows.\n\n"; 

	    S=S+"1. Control panel";
	    S=S+"\n\n2. Vector Selection Window";
	    S=S+"\n\n3. SOL Sphere Window";
	    S=S+"\n\n4. Geodesic checker Window (popup)";
	    S=S+"\n\n5. Triangle Theorem Window (popup)";


	S=S+"\n\n1. CONTROL PANEL FEATURES:\n\n";
	S=S+"You select things in the control panel by clicking in the buttons. Here is what you can do on the control panel;";

	S=S+"\n\n open up the other popup windows.";

	S=S+"\n\nChange the integration stepsize.  This is the stepsize which goes into the computation of SOL geodesics.  The smaller the number, the more accurate the computation.   The tradeoff is that very small stepsizes lead to long calculations.";
	
	S=S+"\n\nChoose to display and recolor a number of objects shown in the other windows.  The blue control panels correspond to the SOL window and the pink control panels correspond to the vector selection windows.";


	    S=S+"\n\n2. SOL SPHERE WINDOW:";

	    S=S+"\n\nThis window plots the image of a sphere of some radius under the exponential map. You use the vector selection window to select the radius.";

	    S=S+"\n\nYou can see 3 different kinds of curves on the Sol sphere:\n\n--the images of the loop level sets (of the function F(x,y,z)=xy)\n\n--the images of the lines of longiture\n\n--the images of the lines of lattitude.\n\nThe number entry fields let you control how much of each kind you see.  When you change these numbers, the result automatically appears on the vector selection window. However, if you want to see the change on the Sol window you have to press the compute button.   It is a bit tedious to change these numbers when you want to switch coordinate systems, so the row of red boxes underneath these number entries lets you manipulate the numbers by clicks.  You have to try it out to see how it works.";

	    S=S+"\n\nYou can use the `symmetry' control panel to deduce whether you plot just the  portion of the sphere in the positive sector or the whole sphere.  The positive sector consists of points (x,y,z) with x,y>0.";
	    
	    S=S+"\n\nYou can use the pitch and yaw sliders to change the view of the plotted object.  Along the same lines, the 3 pink buttons give special projections. ";
	    
	    S=S+"\n\nThere is an animation button which rotates the sphere around.  You can control the speed of the rotation.";

	    S=S+"\n\nThe control panel has a number of drawing features which you can turn on and off.  You can press the question boxes on the control panel to figure out what these do.";


	    S=S+"\n\n3. VECTOR SELECTION WINDOW";

	    S=S+"\n\nThis window shows the unit square. You select a new point by dragging the cursor over the sphere, in the brightly colored sector.   You use the slider at the top to change the radius of the sphere. You use the yaw and pitch sliders to control the view of the sphere.  If you turn on the `geodesic 1' option on the control panel, you can see geodesic segment corresponding to your point.";

	    S=S+"\n\nThe row of boxes underneath the slider controls how the selected radius is rounded to the nearest dyadic rational. I added this feature to make it possible to select numbers very close to exact integers.";
	    
	    S=S+"\n\nThe numbers printed out at the top left give you the coords for the vector you have chosen.  We show the radius of the sphere and the point on the unit sphere corresponding to the selected vector.  When you have the 'marker level' feature on, you can also see information about the period and holonomy of the loop level set associated ti your vector choice.";

	    
	    S=S+"\n\nDomain of diffeomorphy: When the radius is larger than sqrt(2) times Pi, there appears a colored oval in the square.  The complement of the oval is the domain where the exponential map is a diffeomorphism.  The whole SOL sphere is the image of this domain, together with the boundary of the colored domain.  The exponential map identifies this boundary in a 2-1 folding fashion, and this accounts for the singular set in the sphere.";

	    S=S+"Image choice selection: You can use keys 1 and 2 to restrict the plot to an annular region between two loop level sets.  These are level sets of the function F(x,y,z)=xy, intersected with the sphere.  If you turn on the Sol polar option on the control panel, you can see these level sets.";

	    S=S+"\n\n 4. CHECKER WINDOW";

	    S=S+"\n\nThe purpose of this window is just to reassure us that we are computing geodesics correctly.  It s a `sanity check', so to speak. This window shows two things:\n\n1.the projection of the drawn geodesic, rescaled so that its bounding box is the unit square.\n\n2.The projection of a Grayson cylinder, again scaled so that its bounding box is the unit square.\n\nUp to the action of diagonal affine transformations, Grsyson cylinders come in a 1-parameter family. You can adjust the cylinder until it contains the geodesic, provided that the geodesic goes once all the way around the cylinder. You can force this full-loop by clicking on the vector action which says 'set length = period.\n\nThis window is not that exciting visually. Its main purpose is to check the claims about what we call the cylinder axioms:  Every geodesic except the ones contained in a coordinate foliation is contained in a Grayson cylinder. A secondary purpose is to check the appropriateness of the integration stepsize.  If this is too large, the projection will make a kind of coil that does not lie in the projection of a Grayson cylinder.";

	    
	    S=S+"\n\n5. TRIANGLE THEOREM WINDOW";

	    S=S+"\n\nThis window essentially draws the plot for Figure 3 in the paper, which illustrates the crucial Bounding Triangle Theorem. Unlike in the paper, in which we only show the picture for the value L=5.  This window has a slider, and it allows you to draw the plit for any smallish value of L.";

	    DocumentCanvas.setText(D,S);
    }
    

}

