import java.awt.event.*;
import java.awt.*;
import java.math.*;
import java.awt.geom.*;


public class EllipticIntegrals {


    /**Here is the inversion of the period function.
       This works by a bisection algorithm.*/

    public static double periodInverse(double d) {
	if(d<Math.PI*Math.sqrt(2)) return .5;
	double a=0;
	double b=.5;
	double c=.25;
	for(int i=0;i<30;++i) {
	    c=(a+b)/2;
	    double test=EllipticIntegrals.period(c);
	    if(test>=d) a=c;
	    if(test<=d) b=c;
	}
	return c;
    }
    

    /**Here is the period as a function of the quantity a^2.*/

    public static double period(double b) {
	double a=Math.sqrt(b);
	Vector V=new Vector(a,a,Math.sqrt(1-2*b));
	double t=mu(V);
	double per=2*Math.PI/t;
	return per;
    }


    /**This is not used, but it gives the same answer as period*/
    public static double period2(double b) {
	double a=Math.sqrt(b);
	double m=(1-2*a*a)/(1+2*a*a);
	return Math.sqrt(8+8*m)*K(m);
    }



    

/**Here is the mu invariant from the paper/*/

    public static double mu(Vector V) {
	double x=V.x[0];
	double y=V.x[1];
	double z=V.x[2];
	double A0=A(+1,x,y,z);
	double A1=A(-1,x,y,z);
	return AGM(A0+A1,A0-A1);
    }
    

    /**This is the holonomy for the vector (a,a,sqrt(1-2*a*a))*/
    
    public static double holonomy(double a) {
	double b=(1-2*a*a)/(1+2*a*a);
	double c=4*a/Math.sqrt(1+2*a*a);
        double d=K(b)+4*b*dK(b);
	double hol=c*d;
	return hol;
    }


    /**This is not used, but it gives the same value as holonomy*/
    
    public static double holonomy2(double a) {
	double m=(1-2*a*a)/(1+2*a*a);
	return Math.sqrt(4-4*m)*(K(m)+4*m*dK(m));
    }




    
    public static double K(double m) {
	double t=AGM(1,Math.sqrt(1-m));
	return Math.PI/(2*t);
    }

    public static double dK(double m) {
	double h=0.000000001;
	return (K(m+h)-K(m-h))/(2*h);
    }

    public static double AGM(double a,double b) {
	double a0=a;
	double b0=b;
	for(int i=0;i<12;++i) {
	    double a1=Math.sqrt(a0*b0);
	    double b1=(a0+b0)/2;
	    a0=a1;
	    b0=b1;
	}
	return a0;
    }


    public static double A(int sign,double x,double y,double z) {
	double a=Math.abs(x)+sign*Math.abs(y);
	return Math.sqrt(a*a+z*z);
    }

}
