import java.awt.*;
import java.awt.event.*;
import java.math.*;

/**This file does a test for one of the slope calculations in the
   paper.  The idea is to make sure that we have the signs all
   correct.*/

public class DerivativeCalculationTest {



    public static void test() {
	double L=8.7;
	double h=EllipticIntegrals.periodInverse(L);
	Vector U=LevelCurve.sideVector(h);

	System.out.println("holonomy invariant "+h);
	System.out.println("target "+2*h*h);
	System.out.print("vector ");
	U.print();
	 Vector[] V=GeodesicMaker.geodesic(.00001,L,U);
	 Vector[] FLOW=GeodesicMaker.flowline(.00001,L,U);
	 int N=V.length;
	 int skip=N/100;
	 double min=100000;
	 for(int i=(V.length-1)/2;i>=0;i=i-skip) {
	        Vector Z1=new Vector(V[i]);
		Vector Z2=new Vector(V[V.length-1-i]);
		Vector TEST=GroupStructure.leftTranslationInverse(Z1,Z2);
                double a=TEST.x[0];
		double b=TEST.x[1];
		System.out.println("test");
		double x=FLOW[i].x[0];
		double y=FLOW[i].x[1];
		double z=FLOW[i].x[2];
		System.out.println("holonomy "+a+" "+b);
		System.out.println("vector   "+x+" "+y+" "+z);
		double d1=2*y/z;
		double ratio=d1/b;
		if((z>0.000001)&(min>ratio)) min=ratio;
		System.out.println("ratio "+ratio);
		System.out.println("min ratio "+min);
		
	 }
    }




}


