import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class InverseCanvas extends ScaleCanvas implements KeyListener,MouseListener, MouseMotionListener {
    Manager M;
    EnhancedSlider[] COORD=new EnhancedSlider[3];
    Point JX;
    boolean drag;
    Inversor INV;
    ListenSquare GO,STOP;

     public InverseCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 for(int i=0;i<3;++i) {
            COORD[i]=new EnhancedSlider(0,30*i,730,27,365,new Color(0,100,0),"");
	 }
	 COORD[0].forceValue(2*Math.PI);
	 COORD[1].forceValue(2*Math.PI);
	 COORD[2].POS=0;
	 GO=new ListenSquare(0,100,50,20);
	 STOP=new ListenSquare(60,100,60,20);
	 INV=new Inversor(this.M);
     }
    
   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawControls(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(new Color(150,0,200));
        g.fillRect(0,0,getWidth(),getHeight()); 
    }

    public void drawControls(Graphics2D g) {
	for(int i=0;i<3;++i) COORD[i].render(g);
	if(INV.halt==false) STOP.render(g,new Color(200,0,0));
	if(INV.halt==true) GO.render(g,new Color(0,200,0));
    }

    public Vector getVector() {
	Vector V=new Vector();
	for(int i=0;i<3;++i) V.x[i]=COORD[i].getValue();
	return V;
    }

    public void doGo() {
	INV=new Inversor(this.M);
	new Thread(INV).start();
    }
    
        
    public void mousePressed(MouseEvent e) {
	MouseData J=MouseData.process(e);
	for(int i=0;i<3;++i) COORD[i].activate(J.X);
	drag=true;
    }

    
    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
  	for(int i=0;i<3;++i) COORD[i].configure(J.X);
	if(GO.inside(J.X)==1) doGo();
	if(STOP.inside(J.X)==1) INV.halt=true;
	repaint();
    }


     public void mouseReleased(MouseEvent e) {
	 drag=false;	 
     }

     public void mouseEntered(MouseEvent e) {
	 requestFocus();
     }
     public void mouseExited(MouseEvent e) {}   

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	if(drag==true) {
  	    for(int i=0;i<3;++i) COORD[i].configure(J.X);
	}
	JX=J.X;
     }

     public void mouseDragged(MouseEvent e) {
	MouseData J=MouseData.process(e);
	for(int i=0;i<3;++i) COORD[i].configure(J.X);
	M.repaint();
     }
  public void keyTyped(KeyEvent e) {

      char ch=e.getKeyChar();
         M.repaint();
     }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {
    }

}

