import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;


public class Toolbar {
    int x,y;
    int[] COUNT=new int[10];
    double[] SMOOTH=new double[10];
    EnhancedSlider SMOOTH0,POINTS;
    ListenSquare[] CHOICE=new ListenSquare[10];
    ListenSquare[] COLOR=new ListenSquare[10];
    ListenSquare[] RESET=new ListenSquare[10];
    ListenSquare SWITCH0,SWITCH1;
    int MODE;


    public Toolbar(int x,int y) {
	this.x=x;
	this.y=y;
	setup();
	MODE=0;
	for(int i=0;i<10;++i) {
	    COUNT[i]=64;
	    SMOOTH[i]=256;
	}
	SMOOTH0=new EnhancedSlider(x,y,530,27,529,new Color(50,50,255),"smoothness");
	POINTS=new EnhancedSlider(x,30+y,530,27,529,new Color(0,0,200),"points");
	SMOOTH0.POW.val=8;
	POINTS.POW.val=6;
    }

    public void setup() {
	for(int i=0;i<10;++i) {
	    SWITCH0=new ListenSquare(x+120,y+80,17,17);SWITCH0.on=1;
	    SWITCH1=new ListenSquare(x+120,y+100,17,17);SWITCH1.on=0;
            CHOICE[i]=new ListenSquare(180+x+20*i,y+60,17,17);	
            COLOR[i]=new ListenSquare(180+x+20*i,y+80,17,17);
            RESET[i]=new ListenSquare(180+x+20*i,y+100,17,17);
	    COLOR[i].C=Color.white;
	}	
    }

    public void render(Graphics2D g) {
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	if(SWITCH0.on==0) SWITCH0.render(g,Color.black);
	if(SWITCH0.on==1) SWITCH0.render(g,Color.green);
	if(SWITCH1.on==0) SWITCH1.render(g,Color.black);
	if(SWITCH1.on==1) SWITCH1.render(g,Color.green);
	g.drawString("off",x+145,y+93);
	g.drawString("on",x+145,y+113);
	g.drawString("curve drawing tool",x+5,y+73);

	if(active()==false) return;
	
	for(int i=0;i<10;++i) {
	    Color C=Color.blue;
	    if(i==MODE) C=Color.yellow;
            CHOICE[i].render(g,C);
	    COLOR[i].render(g,COLOR[i].C);
	    RESET[i].render(g,Color.black);
	}  
        g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.setColor(Color.white);
	g.drawString("choice",x+390,y+73);
	g.drawString("color",x+390,y+93);
	g.drawString("reset",x+390,y+113);

	SMOOTH0.render(g);
	POINTS.render(g);
    }

    public int curveChoice(Point X) {
	for(int i=0;i<10;++i) {
	    if(CHOICE[i].inside(X)==1) return i;
	}
	return -1;
    }

    public boolean active() {
	if(SWITCH0.on==1) return false;
	return true;
    }
    

    public int process(Point X,Color C) {
	
	if(SWITCH0.inside(X)==1) {
	    SWITCH0.on=1;
	    SWITCH1.on=0;
	}

	if(SWITCH1.inside(X)==1) {
	    SWITCH0.on=0;
	    SWITCH1.on=1;
	}
	
	for(int i=0;i<10;++i) {
	    if(CHOICE[i].inside(X)==1) MODE=i;
	    if(COLOR[i].inside(X)==1) COLOR[i].C=new Color(C.getRed(),C.getGreen(),C.getBlue());
	    if(RESET[i].inside(X)==1) return i;
	}
	return -1;
    }



}



