import java.awt.event.*;
import java.awt.*;
import java.awt.geom.*;

public class NumberEntry {
    double x,y,w,h;
    String S;
    int on;

    public NumberEntry(String S) {
	this.S=S;
    }

    public NumberEntry(double x,double y,double w,double h,String S) {
	this.x=x;
	this.y=y;
	this.w=w;
	this.h=h;
	this.S=S;
    }

    public int inside(Point p) {
        int test=0;
	if((p.x>x)&&(p.x<x+w)&&(p.y>y)&&(p.y<y+h)) test=1;
	return(test);
    }

    /** drawing methods */

    public void render(Graphics g,Color C1,Color C2,Color C3) {
	g.setColor(C1);
	g.fillRect((int)(x),(int)(y),(int)(w),(int)(h));
        g.setColor(C2);
	if(on==1) g.setColor(Color.white);
	if(on==0) g.setColor(Color.blue);
	g.drawRect((int)(x),(int)(y),(int)(w),(int)(h));
	g.setColor(C3);
	g.setFont(new Font("Helvetic",Font.PLAIN,15));
	g.drawString(S,(int)(x+5),(int)(y+h-3));
    }

    public int activate(Point X) {
	if(inside(X)==1) on=1;
	if(inside(X)==0) on=0;
	return 0;
    }

    public boolean modify(KeyEvent e) {
	if(on==0) return(false);
	int n=S.length();
	char a=e.getKeyChar();

        if (a==KeyEvent.VK_BACK_SPACE) {
	    if(n>0) S=S.substring(0,n-1);
        }
	
        int ch=(int)(a-'0');
        if ((ch>=0)&&(ch<=9)) S=S+ch;
	if(ch==-2) S=S+".";

	if(ch==-3) {
	   S="-"+S;
	   if(n>1) {
	     String T=S.substring(0,2);
	     if(T.equals("--")==true) S=S.substring(2,n+1);
	   }
	}
	
	return(true);
    }

    public int getInteger() {
	Double d=new Double(1);
	try{
	   d=new Double(S);
	}
	catch(Exception e) {return 1;}
	int n=d.intValue();
	return n;
    }

}
