import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;
import java.math.*;


public class Tracer implements Runnable {
    Manager M;
    boolean halt;

    public Tracer() {
	halt=true;
    }

    public Tracer(Manager MM) {
	this.M=MM;
	halt=true;
    }

    public void run() {
	halt=false;
	M.C.DISPLAY.L[6].on=1;
	double[] A=M.V.V.sphereToChart();
        double r0=Math.sqrt(A[0]*A[0]+A[1]*A[1]);
	

	while(halt==false) {
	    double step=-.04*Math.pow(.5,10-M.C.SPEED.val);
	    Complex move=new Complex(Math.cos(step),Math.sin(step));
	    Vector U=new Vector(M.V.V);
	    A=U.sphereToChart();
	    Complex z=new Complex(A[0],A[1]);
	    z=Complex.times(z,move);
	    z=z.unit();
    	    z=z.scale(r0);
	    M.V.V=Vector.chartToSphere(z.x,z.y);
	    M.B.computeGeodesic();
	    M.repaint();
	}
    }


    /**enhanced projection to level curve - not used right now*/

    public static Vector enhancedProjection(double f,Vector V) {
	Vector U=new Vector(V);
	for(int i=0;i<10;++i) {
	    U=toHyperbola(f,U);
	    U=V.unit();
	}
	return U;
    }

    public static Vector toHyperbola(double f,Vector V) {
	double x=V.x[0];
	double y=V.x[1];
	double z=V.x[2];
        double b=(-Math.pow(x,2) - Math.pow(y,2) +
	        Math.sqrt(Math.pow(x,4) + 4*f*x*y -
			  2*Math.pow(x,2)*Math.pow(y,2) +
			  Math.pow(y,4)))/(2*x*y);
       Vector W=new Vector(x+b*y,y+b*x,z);
       return W;
    }

    
}
