import java.awt.event.*;
import java.awt.*;
import java.math.*;
import java.awt.geom.*;


public class GeodesicAnalyzer {

    /**This is a routine for a collection of points, which
       changes the aspect ratio so that they fit maximally
       inside the unit square [0,1[^2*/
    
    public static double[][] fitInSquare(double[][] t) {
	double[][] u=new double[t.length][2];
	double[] B=boundingBox(t);
	double ax=1/(B[2]-B[0]);
	double bx=B[0]/(B[0]-B[2]);
	double ay=1/(B[3]-B[1]);
	double by=B[1]/(B[1]-B[3]);
	for(int i=0;i<t.length;++i) {
	    u[i][0]=ax*t[i][0]+bx;
	    u[i][1]=ay*t[i][1]+by;
	}
	return u;
    }

    /**this gets xmin,ymin,xmax,ymax*/

    public static double[] boundingBox(double[][] t) {
	double xmin=10000;
	double ymin=10000;
	double xmax=-10000;
	double ymax=-10000;
	for(int i=0;i<t.length;++i) {
	    if(xmin>t[i][0]) xmin=t[i][0];
	    if(ymin>t[i][1]) ymin=t[i][1];
	    if(xmax<t[i][0]) xmax=t[i][0];
	    if(ymax<t[i][1]) ymax=t[i][1];
	}
	double[] B={xmin,ymin,xmax,ymax};
	return B;
    }

    
    public static double[][] elevationGeodesic(double c,double s,Vector[] V) {
	double[][] pro=new double[V.length][2];
	for(int i=0;i<V.length;++i) {
	    pro[i]=project(c,s,V[i]);
	}
	return pro;
    }

    
    public static double[][] planGeodesic(double c,double s,Vector[] V) {
	double[][] pro=new double[V.length][2];
	for(int i=0;i<V.length;++i) {
	    pro[i][0]=V[i].x[0];
	    pro[i][1]=V[i].x[1];
	}
	return pro;
    }




    public static double[] project(double c,double s,Vector V) {
	double x=V.x[0];
	double y=V.x[1];
	double a=s*x-c*y;
	double[] A={a,V.x[2]};
	return A;
    }
    
    

}
