import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.awt.geom.*;
import java.math.*;


public class VectorCanvas extends ScaleCanvas implements MouseListener, MouseMotionListener, KeyListener {
    Manager M;
    Vector V;
    Point JX;
    boolean drag;
    ListenSquare CONTROL;
    EnhancedSlider RADIUS;
    EnhancedSlider PITCH,YAW;
    Vector[][] POINT0=new Vector[20][1000];
    Vector[][] POINT1=new Vector[20][1000];

     public VectorCanvas() {
	 addMouseListener(this);
	 addMouseMotionListener(this);
	 addKeyListener(this);
	 setScales(300,340,190);
	 V=new Vector(.6,0,.8);
	 CONTROL=new ListenSquare(0,0,600,90);
	 RADIUS=new EnhancedSlider(0,0,530,27,530,new Color(200,0,200),"radius");
	 YAW=new EnhancedSlider(0,30,530,27,265,new Color(0,0,255),"yaw");
	 PITCH=new EnhancedSlider(0,60,530,27,265,new Color(0,160,0),"pitch");
	 PITCH.forceValue(.25);
	 YAW.forceValue(.25);
	 drag=false;
     }

   public void paint(Graphics g2) {
      Graphics2D g=(Graphics2D) g2;
      g.setRenderingHint(RenderingHints.KEY_ANTIALIASING,RenderingHints.VALUE_ANTIALIAS_ON);
      drawBG(g);
      drawCoords(g);
      drawBall(0,g);
      drawBall(1,g);
      drawVector(g);
      drawAxes(g);
      drawControls(g);
   }

    public void drawBG(Graphics2D g) {
	g.setColor(M.C.DISPLAY.M[5].C);
        g.fillRect(0,0,getWidth(),getHeight());
	fillPoint(g,new Complex(0,0),1,M.C.DISPLAY.M[6].C,2000);
    }
    public void drawVector(Graphics2D g) {
	double[] A=view(V);
	Path2D.Double gp=new Path2D.Double();
	gp.moveTo(A[0],A[1]);
	gp.lineTo(A[0],A[1]);
	g.setColor(new Color(255,255,255,60));
	int t=3;
	if(A[2]>0) t=6;
	if(A[2]>0) g.setColor(Color.white);

	g.setStroke(new BasicStroke(t));
	gp=transform(gp);
	g.draw(gp);
	g.setStroke(new BasicStroke(1));
    }

    public void drawControls(Graphics2D g) {
	RADIUS.render(g);
	PITCH.render(g);
	YAW.render(g);
    }

    public void drawAxes(Graphics2D g) {
	Path2D.Double gp=new Path2D.Double();

	gp.reset();
	for(int i=0;i<300;++i) {
	    double s=1.0*i/300;
	    double ss=1.0*(i+1)/300;
	    Vector V0=Vector.spherePoint(s,.5);
	    Vector V1=Vector.spherePoint(ss,.5);
	    double[] A0=view(V0);
	    double[] A1=view(V1);
	    if(A0[2]>-.0001) {
	       gp.moveTo(A0[0],A0[1]);
	       gp.lineTo(A1[0],A1[1]);
	    }
	}

        gp.closePath();
        gp=transform(gp);
	g.setColor(new Color(255,130,0));
	g.draw(gp);

	Color[] COL={new Color(200,0,0),new Color(120,120,255)};
	for(int j=0;j<8;++j) {
	    double angle=1.0*j/8;


	  gp.reset();
	  for(int i=0;i<300;++i) {
	    double s=1.0*i/300;
	    double ii=i+1;
	    double ss=1.0*ii/300;
	    Vector V0=Vector.spherePoint(angle,s);
	    Vector V1=Vector.spherePoint(angle,ss);
	    double[] A0=view(V0);
	    double[] A1=view(V1);
	    if(A0[2]>0) {
	       gp.moveTo(A0[0],A0[1]);
	       gp.lineTo(A1[0],A1[1]);
	    }
	  gp=transform(gp);
	  g.setColor(COL[j%2]);
	  g.draw(gp);
	  }
	}

    }


    public void doLocks() {
	int t=M.C.ACTION.mode;

	if(t==1) {
	    V.x[2]=0;
	    V=V.unit();
	}
	if(t==2) {
	    double a=V.x[0]+V.x[1];
	    a=a/2;
	    V.x[0]=a;
	    V.x[1]=a;
	    V=V.unit();
	}

	if(t==3) {
	    YAW.forceValue(.25);
	    PITCH.forceValue(.25);
	}

	if(t==4) {
	    double crit=Math.PI*Math.sqrt(2);
	    RADIUS.forceValue(crit);
	}

	if(t==5) {
	    double step=M.C.getStepsize();
    	    double[] data=GeodesicMaker.periodData(0,step,V);
	    RADIUS.forceValue(data[0]);
	}
    }






    public Vector pitch(Vector V) {
  	  double t=PITCH.getValue();
	  t=2*Math.PI*t;
	  return Vector.pitch(t,V);
    }

    public Vector yaw(Vector V) {
	double t=YAW.getValue();
	t=2*Math.PI*t;
	return Vector.yaw(t,V);
    }

    public Vector pitchInverse(Vector V) {
  	  double t=PITCH.getValue();
	  t=2*Math.PI*t;
	  return Vector.pitch(-t,V);
    }

    public Vector yawInverse(Vector V) {
	double t=YAW.getValue();
	t=2*Math.PI*t;
	return Vector.yaw(-t,V);
    }


    public void drawCoords(Graphics2D g) {
	g.setFont(new Font("Helvetica",Font.PLAIN,14));
	g.setColor(Color.white);
	for(int i=0;i<3;++i) {
	    Double D=new Double(V.x[i]);
	    g.drawString(D.toString(),10,120+20*i);
	}
    }

    public void setUnitVector() {
	setUnitVector(SOURCE);
	doLocks();
    }

    public void setUnitVector(Complex z) {
	double d=z.norm();
	if(d>1) z=z.unit();
	d=z.norm();
	V.x[0]=z.x;
	V.x[2]=z.y;
	V.x[1]=Math.sqrt(1-d*d);
	V=yawInverse(V);
	V=pitchInverse(V);
	M.B.computeGeodesic(M.C.GEOM.mode);
    }





    public double[] view(Vector V) {
	Vector W=pitch(V);
	W=yaw(W);
	double[] A={W.x[0],W.x[2],W.x[1]};
	return A;
    }

    public double[] viewInverse(Vector V) {
	Vector W=yawInverse(V);
	W=pitchInverse(W);
	double[] A={W.x[0],W.x[2]};
	return A;
    }

    public void drawBall(int choice,Graphics2D g) {
	if(M.C.DISPLAY.L[7].on==0) return;
	Color COL=M.C.DISPLAY.M[7].C;
	g.setColor(COL);

	int LIM=0;
	if(choice==0) LIM=M.B.LATT;
	if(choice==1) LIM=M.B.LONG;

	    for(int j=0;j<LIM;++j) {
		Path2D.Double gp=new Path2D.Double();
	        for(int i=0;i<M.B.DETAIL;++i) {
		    int ii=i+1;
		    Vector V0=M.B.SPHERE[choice][i][j];
		    Vector V1=M.B.SPHERE[choice][ii][j];
		    double[] A0=view(V0);
		    double[] A1=view(V1);
		    if(A0[2]>0) {
		      gp.moveTo(A0[0],A0[1]);
		      gp.lineTo(A1[0],A1[1]);
		    }
		}
		gp=transform(gp);
		g.draw(gp);
	    }
    }



    

    public void mousePressed(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	RADIUS.activate(J.X);
        PITCH.activate(J.X);
	YAW.activate(J.X);
	drag=true;
    }


    public void mouseClicked(MouseEvent e) { 
	MouseData J=MouseData.process(e);
	doMouseClick(J.mode);
    }

    public void doMouseClick(int mode) { 
	if(CONTROL.inside(JX)==1) {
	    RADIUS.configure(JX);
	    PITCH.configure(JX);
	    YAW.configure(JX);
	    doLocks();
	    M.repaint();
	    return;
	}
        if(mode==1)  scaleUp(JX,0);
        if(mode==3)  scaleUp(JX,1);
	if(mode==2) SOURCE=unTransform(JX);
	setUnitVector();
	M.repaint();
    }
     public void mouseReleased(MouseEvent e) {	
	 drag=false; 
     }

     public void mouseEntered(MouseEvent e) {}
     public void mouseExited(MouseEvent e) {
	 requestFocus();
     }  

     public void mouseMoved(MouseEvent e) {
	MouseData J=MouseData.process(e);
	JX=J.X;
	if(drag==true) {
	    SOURCE=unTransform(J.X);
	}
     }

     public void mouseDragged(MouseEvent e) {

	MouseData J=MouseData.process(e);
	if(CONTROL.inside(J.X)==1) {
	    RADIUS.configure(J.X,true);
	    PITCH.configure(J.X,true);
	    YAW.configure(J.X,true);
  	    M.repaint();
	    return;

	}
	if(J.mode==2) SOURCE=unTransform(J.X);

	setUnitVector();
	M.repaint();
	 
     }

  public void keyTyped(KeyEvent e) {
      char ch=e.getKeyChar();
      if(ch=='z') doMouseClick(1);
      if(ch=='x') doMouseClick(2);
      if(ch=='c') doMouseClick(3);      
     }
    public void keyPressed(KeyEvent e) {}
    public void keyReleased(KeyEvent e) {
    }

}

